
`default_nettype none

module top(
	input  wire Clock,				// 20 (25MHz)
	input  wire Reset,				// 17
	input  wire Rx_i,				// 75 User Interface, 48 Segment14
	
	output wire [7:0] Cathodes_o,
	output wire [7:0] Segments_o
);

	parameter CLOCK_HZ = 25_000_000;
	
	// Odbiornik UART
	wire RxDone;
	wire [7:0] RxData;
	
	UartRx #(
		.CLOCK_HZ(CLOCK_HZ),
		.BAUD(115200)
	) UartRx_Inst(
		.Clock(Clock),
		.Reset(Reset),
		.Rx_i(Rx_i),
		.Done_o(RxDone),
		.Data_o(RxData)
	);
	
	// Wywietlanie czterech ostatnio odebranych bajtw
	reg [31:0] DataToDisplay;
	always @(posedge Clock, negedge Reset) begin
		if(!Reset)
			DataToDisplay <= 0;
		else if(RxDone)
			DataToDisplay[31:0] <= {DataToDisplay[23:0], RxData};
	end
	
	DisplayMultiplex #(
		.CLOCK_HZ(CLOCK_HZ),
		.SWITCH_PERIOD_US(1000),
		.DIGITS(8)
	) DisplayMultiplex0(
		.Clock(Clock),
		.Reset(Reset),
		.Data_i(DataToDisplay),
		.DecimalPoints_i(8'b01010101), 
		.Cathodes_o(Cathodes_o),
		.Segments_o(Segments_o),
		.SwitchCathode_o()
	);
	
	

endmodule

`default_nettype wire
